library("survival")

pix.hap<-function(mom, dad, case, sex, cutoff= 0.01){
	SNPs = dim(case)[2]
	fams = dim(case)[1]
	hapN = 2^SNPs
	haps = array(0,c(hapN, SNPs))
	for(i in 1:SNPs){
		haps[,i]  = rep(c(rep(0, 2^(SNPs-i)), rep(1, 2^(SNPs-i))), 2^(i-1))	
	}
	
	haps.c = paste(haps[,1])
	for(i in 2:SNPs){
		haps.c = paste(haps.c, haps[,i])
	}

	dad.hap1 = dad
	mom.hap1 = mom
	mom.hap2 = mom
	case.hap1 =mom
	case.hap2 = mom
	for(i in 1:dim(case)[1]){
		if(sex[i]==0){
			case.hap1[i,] = case[i,]
			case.hap2[i,] = case[i,]
			mom.hap1[i,]= case[i,]
			mom.hap2[i,]= mom[i,]-case[i,]
		}	
		if(sex[i]==1){
			case.hap1[i,] = dad.hap1[i,]
			case.hap2[i,] = case[i,]-dad.hap1[i,]
			mom.hap1[i,]= case.hap2[i,]
			mom.hap2[i,]= mom[i,]-case.hap2[i,]		
		}	
	}


	mom.hap1.c = paste(mom.hap1[,1])
	mom.hap2.c = paste(mom.hap2[,1])
	dad.hap1.c = paste(dad.hap1[,1])
	case.hap1.c = paste(case.hap1[,1])
	case.hap2.c = paste(case.hap2[,1])
	for(i in 2:SNPs){
		mom.hap1.c = paste(mom.hap1.c,mom.hap1[,i])
		mom.hap2.c = paste(mom.hap2.c,mom.hap2[,i])
		dad.hap1.c = paste(dad.hap1.c,dad.hap1[,i])
		case.hap1.c = paste(case.hap1.c,case.hap1[,i])
		case.hap2.c = paste(case.hap2.c,case.hap2[,i])
	}

	pix.case.hap1 = rep(0, fams)
	pix.case.hap2 = rep(0, fams)
	pix.mom.hap1 = rep(0, fams)
	pix.mom.hap2 = rep(0, fams)
	pix.dad.hap1 = rep(0, fams)
	
	for(i in 1:fams){
		if(length(which(haps.c==mom.hap1.c[i]))==0 ||
			length(which(haps.c==mom.hap2.c[i]))==0 ||
			length(which(haps.c==dad.hap1.c[i]))==0 ||
			length(which(haps.c==case.hap1.c[i]))==0 ||
			length(which(haps.c==case.hap2.c[i]))==0){
				pix.mom.hap1[i] = NA
				pix.mom.hap2[i] = NA
				pix.dad.hap1[i] = NA
				pix.case.hap1[i] = NA
				pix.case.hap2[i] = NA	
			}
		else{pix.mom.hap1[i] = which(haps.c==mom.hap1.c[i])
			pix.mom.hap2[i] = which(haps.c==mom.hap2.c[i])
			pix.dad.hap1[i] = which(haps.c==dad.hap1.c[i])
			pix.case.hap1[i] = which(haps.c==case.hap1.c[i])
			pix.case.hap2[i] = which(haps.c==case.hap2.c[i])	
		}
	}
		
	remove = which(is.na(pix.mom.hap1))
	if(length(remove)>0){
		pix.mom.hap1 = pix.mom.hap1[-remove]
		pix.mom.hap2 = pix.mom.hap2[-remove]
		pix.dad.hap1 = pix.dad.hap1[-remove]
		pix.case.hap1 = pix.case.hap1[-remove]
		pix.case.hap2 = pix.case.hap2[-remove]
		sex = sex[-remove]
	}
	
	
	fams = fams-length(remove)	

	geno1 = array(0, c(3*fams, dim(haps)[1]))
	pid = array(0, 3*fams)
	for(i in 1:fams){
		if(sex[i] ==1){
			geno1[3*i-2,pix.case.hap1[i]]=geno1[3*i-2,pix.case.hap1[i]]+1 
			geno1[3*i-2,pix.case.hap2[i]]=geno1[3*i-2,pix.case.hap2[i]]+1 
			
			other_trans = pix.mom.hap1[i]+pix.mom.hap2[i]+pix.dad.hap1[i]-
				pix.case.hap1[i]-pix.case.hap2[i]
				
			geno1[3*i-1,pix.case.hap1[i]]=geno1[3*i-1,pix.case.hap1[i]]+1 
			geno1[3*i-1,other_trans]=geno1[3*i-1,other_trans]+1 

			geno1[3*i,other_trans]=geno1[3*i,pix.case.hap1[i]]+1 
			geno1[3*i,pix.case.hap2[i]]=geno1[3*i,pix.case.hap2[i]]+1 
		}
		
		if(sex[i] ==0){
			geno1[3*i-2,pix.case.hap1[i]]=2 
			
			geno1[3*i-1,pix.dad.hap1[i]]=2 
			
			non_trans = pix.mom.hap1[i]+pix.mom.hap2[i] - pix.case.hap1[i]
			geno1[3*i,non_trans]=2		
		}
		
		pid[3*i]=i;
		pid[3*i-1]=i;	
		pid[3*i-2]=i;	
	}
	
	status = rep(c(1,0,0), fams)
	sex2 = cbind(sex,sex, sex)
	sex3 = as.vector(t(sex2))
	
	frequency = apply(geno1[sex3==1,], 2, sum)/2+apply(geno1[sex3==0,], 2, sum)/2
	freq = frequency/(3*fams)
	high = which(freq == max(freq))[[1]]

	merge = which(freq<cutoff)
	geno2 = geno1[,-high]
	stop = 1
	
	pix.p = c(NA,NA)
	
	if(length(merge)==1){
		small = geno1[,merge]
		if(sum(small)>0){geno2 = cbind(small, geno1[,-c(merge, high)])	
			stop = 2	}	
		if(sum(small)==0){geno2 = geno1[,-c(merge, high)]	
			stop = 1	}		
	}
	
	if(length(merge)>1){
		small = apply(geno1[,merge], 1, sum)	
		if(sum(small)>0){geno2 = cbind(small, geno1[,-c(merge, high)])	
			stop = 2	}	
		if(sum(small)==0){geno2 = geno1[,-c(merge, high)]	
			stop = 1	}	
	}

	if(stop ==1){
		try0 <- try(pix.output1 <- clogit(status~geno2+strata(pid)))
		if (class(try0) !="try-error") pix.p=summary(pix.output1)$logtest[1:2]
	}
	
	if(stop ==2){
		try1 <- try(pix.output1 <- clogit(status~geno2+strata(pid)));
		try2 <- try(pix.output2 <- clogit(status~geno2[,1]+strata(pid)));
		if (class(try1) !="try-error" && class(try2) !="try-error") pix.p=(summary(pix.output1)$logtest[1:2]-summary(pix.output2)$logtest[1:2])
	}
	
	return(pix.p)
}





